=== debian/changelog ===
shim (13-0ubuntu2) bionic; urgency=medium

  * debian/patches/abort_abort_abort.patch: signtool.exe isn't happy with some
    of the structure of our binary, partly because abort() is thought to be an
    external symbol, which causes some relocalisations to appear.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 07 Nov 2017 10:19:04 -0500

shim (13-0ubuntu1) artful; urgency=medium

  * New upstream release: 13
  * debian/control: add a Build-Depends on libelf-dev.
  * debian/control: add Breaks: for the previous shim-signed builds given
    that shim will now build and ship BOOT.CSV by itself.
  * debian/rules:
    - Update dh_auto_build/dh_auto_clean/dh_auto_install for new upstream
      options: set MAKELEVEL.
    - Define an EFI_ARCH variable, and use that for paths to shim. This
      makes it possible to build a shim for other architectures than amd64.
    - Set EFIDIR=ubuntu for dh_auto_install; that will let files be installed
      in the "right" final directories, and makes boot.csv for us.
    - Set ENABLE_SHIM_CERT, to keep using ephemeral self-signed certs built
      at compile-time for MokManager and fallback.
    - Set ENABLE_SBSIGN, to use sbsign instead of pesign for signing fallback
      and MokManager.
  * debian/patches/second-stage-path: dropped; the default loader path now
    includes an arch suffix.
  * debian/patches/sbsigntool-no-pesign: dropped; no longer needed..
  * debian/patches/0001-shim-fix-the-mirroring-MokSBState-fail.patch: dropped,
    included upstream.
  * debian/shim.install: update paths in light of using shim's upstream install
    target.
  * debian/rules, debian/shim.install: make sure the 'make install' step does
    what it's meant to do by upstream: we can easily make use of the end result
    to have the files we need.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 29 Sep 2017 15:11:28 -0400

shim (0.9+1474479173.6c180c6-1ubuntu1) zesty; urgency=medium

  [ Steve Langasek ]
  * Merge (not yet NEW cleared) changes from Debian branch.

  [ Mathieu Trudel-Lapierre ]
  * debian/patches/0001-shim-fix-the-mirroring-MokSBState-fail.patch: guard
    against errors in mirroring MokSBState to MokSBStateRT. Thanks to Ivan Hu
    for the patch. This will fix issues updating MokSBStateRT if the variable
    already exists with different attributes. (LP: #1644806)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 01 Dec 2016 16:55:50 -0500

shim (0.9+1474479173.6c180c6-0ubuntu1) yakkety; urgency=medium

  [ Helen Koike ]
  * debian/copyright: add OpenSSL license 

  [ Mathieu Trudel-Lapierre ]
  * New upstream release. (LP: #1624096)
  * debian/copyright: patches should be BSD, like the rest of the upstream
    code.
  * debian/patches/unused-variable: dropped; applied upstream.
  * debian/patches/binutils-version-matching: dropped, fixed upstream.
  * debian/shim.install: built EFI binaries were renamed; update our install
    file to properly pick up shim (shim$arch), MokManager (mm$arch), and
    fallback (fb$arch).

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 22 Sep 2016 15:02:20 -0400
