=== debian/control ===
--- 
+++ 
@@ -1,14 +1,16 @@
 Source: shim
 Section: admin
 Priority: optional
-Maintainer: Steve Langasek <vorlon@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Steve Langasek <vorlon@debian.org>
 Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9), gnu-efi (>= 3.0u), sbsigntool, openssl
+Build-Depends: debhelper (>= 9), gnu-efi (>= 3.0u), sbsigntool, openssl, libelf-dev
 Vcs-Bzr: lp:~ubuntu-core-dev/shim/trunk
 
 Package: shim
 Architecture: amd64
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: shim-signed (<< 1.33~)
 Description: boot loader to chain-load signed boot loaders under Secure Boot
  This package provides a minimalist boot loader which allows verifying
  signatures of other UEFI binaries against either the Secure Boot DB/DBX or
