=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="repack,compression=xz,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/shim-$1\.tar\.gz/" \
  https://github.com/mjg59/shim/releases .*/v?(\d\S*)\.tar\.gz
